SystemOrganization addCategory: #'ICU-NativeBoost-Core'!

Object subclass: #ICUNativeBoost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 10:27'!
getDefaultTimeZone
	"self getDefaultTimeZone"
	
	| buffer1 buffer2 length |
	
	buffer1 := ByteArray new: 200.
	buffer2 := ICUErrorCodeNB new.
	
	length := self getDefaultTimeZone: buffer1 with: buffer1 size / 2 with: buffer2. 
	
	^TwoByteString fromByteArray: buffer1 charSize: length! !

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/17/2012 09:29'!
getDefaultTimeZone: aResultBuffer with: aResultCapacity with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int ucal_getDefaultTimeZone_48( void* aResultBuffer, int aResultCapacity, ICUErrorCodeNB* anErrorCode ) ) module: self inModule 
	
! !

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/12/2012 17:28'!
getEnv:  aName
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ NBFFICallout cdecl: #( String  getenv( String aName) ) module: NativeBoost CLibrary
	
! !

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/12/2012 21:43'!
inModule

	^ NativeBoost forCurrentPlatform loadModule: 'libicui18n.dylib'! !

!ICUNativeBoost class methodsFor: 'as yet unclassified' stamp: 'jvds 2/12/2012 21:36'!
ucModule

	^ NativeBoost forCurrentPlatform loadModule: 'libicuuc.dylib'! !

NBExternalObject subclass: #ICUEnumerationNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUEnumerationNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:43'!
byteStringCollection: anEnumAddress

	^ Array streamContents: [ :stream |
		| status result |
		status := ICUErrorCodeNB new.
		[ result := self primNext: anEnumAddress with: status. status check. result isNil ]
			whileFalse: [ stream nextPut: result readString ].
		self primClose: anEnumAddress ]! !

!ICUEnumerationNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:39'!
nbLibraryNameOrHandle

	^'libicui18n.dylib'! !

!ICUEnumerationNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:42'!
primClose: aHandle
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void uenum_close_48( void* aHandle) )! !

!ICUEnumerationNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:38'!
primNext: aHandle with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( char* uenum_next_48(void* aHandle, nil, ICUErrorCodeNB* anErrorCode ) )! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 16:56'!
asByteStringCollection
	"Get all elements of this enumeration as single byte Strings and close this enumeration."

	^ Array streamContents: [ :stream |
		| status result |
		status := ICUErrorCodeNB new.
		[ result := self primNext: status. status check. result isNil ]
			whileFalse: [ stream nextPut: result readString ].
		self primClose ]! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/13/2012 21:53'!
close

	self primClose ! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 16:51'!
next

	| value status resultLength |

	value := self primNext: (status := ICUErrorCodeNB new).
	^ value readString! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 16:49'!
primClose
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void uenum_close_48( self ) )! !

!ICUEnumerationNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 16:49'!
primNext: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( char* uenum_next_48( self, nil, ICUErrorCodeNB* anErrorCode ) )! !

NBExternalStructure variableByteSubclass: #ICUErrorCodeNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUErrorCodeNB class methodsFor: 'fields description' stamp: 'jvds 2/12/2012 21:53'!
fieldsDesc
	^#(
		ulong status;	" # of last request processed by server "
	)! !

!ICUErrorCodeNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:38'!
check

	self status > 0
		ifTrue: [ self error: 'ICU Error: ', self status printString ]! !

Object subclass: #ICUHandleNB
	instanceVariableNames: 'address'
	classVariableNames: ''
	poolDictionaries: 'ICUConstants'
	category: 'ICU-NativeBoost-Core'!

ICUHandleNB subclass: #ICUCalendarNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUCalendarNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 16:54'!
allTimeZones

	| enum status |
	
	enum := self primOpenTimeZones: (status := ICUErrorCodeNB new).
	status check.
	^ enum asByteStringCollection ! !

!ICUCalendarNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 15:08'!
getDefaultTimeZone
	"self getDefaultTimeZone"
	
	| buffer1 status length |
	
	buffer1 := ByteArray new: 100.
	status := ICUErrorCodeNB new.
	
	length := self primGetDefaultTimeZone: buffer1 with: buffer1 size / 2 with: status.
	status check. 
	
	^TwoByteString fromByteArray: buffer1 charSize: length! !

!ICUCalendarNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 14:34'!
openDefaultWithDefaultLocaleAndTimezone
	"^<UCalendar> Opens a default calendar for the default time zone - but no locale is set
	
	"
	| defaultTimezone |
	
	defaultTimezone := self getDefaultTimeZone.
	^self openDefaultWithLocale: nil timezone: defaultTimezone! !

!ICUCalendarNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 14:22'!
openDefaultWithLocale: localeString timezone: timezoneString

	| address status |
	
	address := self primOpen: timezoneString asUTF16Bytes
		with: timezoneString size
		with: localeString 
		with: 0
		with: (status := UErrorCode new).
	status check.
		
	^self newWithAddress: address! !

!ICUCalendarNB class methodsFor: 'native calls' stamp: 'jvds 2/24/2012 14:26'!
primGetDefaultTimeZone: aResultBuffer with: aResultCapacity with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int ucal_getDefaultTimeZone_48( void* aResultBuffer, int aResultCapacity, ICUErrorCodeNB* anErrorCode ) )
	
! !

!ICUCalendarNB class methodsFor: 'native calls' stamp: 'jvds 2/24/2012 14:38'!
primOpen: aZoneID with: aZoneIDLength with: aLocale with: aCalendarType with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void* ucal_open_48( void* aZoneID, int aZoneIDLength, char* aLocale, int aCalendarType, ICUErrorCodeNB* anErrorCode ) )! !

!ICUCalendarNB class methodsFor: 'native calls' stamp: 'jvds 2/24/2012 16:54'!
primOpenTimeZones: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( ICUEnumerationNB ucal_openTimeZones_48( ICUErrorCodeNB* anErrorCode ) )! !

!ICUCalendarNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 14:28'!
dstOffset
	"^<Integer>	Field number indicating the daylight savings offset in milliseconds. "
	
	^self get: UCAL_DST_OFFSET ! !

!ICUCalendarNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 14:05'!
get: aFieldCode

	| status |
	
	status := ICUErrorCodeNB new.
	^ self primGet: aFieldCode with: status! !

!ICUCalendarNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 14:02'!
primGet: aFieldCode with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( long ucal_get_48( void* self address, long aFieldCode, ICUErrorCodeNB* anErrorCode ) )! !

!ICUCalendarNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 14:05'!
zoneOffset
	"^<Integer>	Field number indicating the daylight savings offset in milliseconds. "
	
	^self get: UCAL_ZONE_OFFSET ! !

ICUHandleNB subclass: #ICUConverterNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICUConverterNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:47'!
allNames

	| enumAddress status |
		
	enumAddress := self primOpenTimeZones: (status := ICUErrorCodeNB new).
	status check.
	^ ICUEnumerationNB byteStringCollection: enumAddress 
! !

!ICUConverterNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:45'!
nbLibraryNameOrHandle

	^'libicui18n.dylib'! !

!ICUConverterNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 15:21'!
open: aConverterName

	| address status |
	
	address := self primOpen: aConverterName with: (status := ICUErrorCodeNB new).
	status check.

	^ self newWithAddress: address
	
	"self open: 'UTF-8'"! !

!ICUConverterNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 15:40'!
openISO_8859_1

	^ self open: 'ISO-8859-1'! !

!ICUConverterNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 15:37'!
openUTF32

	^ self open: 'UTF-32'! !

!ICUConverterNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 15:28'!
openUTF8

	^ self open: 'UTF-8'! !

!ICUConverterNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 15:21'!
primOpen: aConverterName with: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void* ucnv_open_48( char* aConverterName, ICUErrorCodeNB* anErrorCode ) )! !

!ICUConverterNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:31'!
primOpenTimeZones: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void* ucnv_openAllNames_48( ICUErrorCodeNB* anErrorCode ) )! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 16:03'!
byteStringFromUChars: aString

	^ self withStatusDo: [ :status |
		| buffer length |
		buffer := ByteString new: 100.
		length := self primFromUChars: buffer with: buffer size with: aString asUTF16Bytes with: aString size with: status.
		buffer copyFrom: 1 to: length ]! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 15:23'!
close

	self primClose ! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 16:01'!
fromUChars: aString

	^ self withStatusDo: [ :status |
		| buffer length |
		buffer := String new: 100.
		length := self primFromUChars: buffer with: buffer size with: aString asUTF16Bytes with: aString size with: status.
		buffer copyFrom: 1 to: length ]! !

!ICUConverterNB methodsFor: 'testing' stamp: 'jvds 2/24/2012 15:36'!
isAmbiguous

	^ self primIsAmbiguous ! !

!ICUConverterNB methodsFor: 'testing' stamp: 'jvds 2/24/2012 15:36'!
isFixedWidth

	^ self withStatusDo: [ :status | self primIsFixedWidth: status ]! !

!ICUConverterNB methodsFor: 'accessing' stamp: 'jvds 2/24/2012 16:26'!
maxCharSize

	^ self primMaxCharSize ! !

!ICUConverterNB methodsFor: 'accessing' stamp: 'jvds 2/24/2012 16:26'!
minCharSize

	^ self primMinCharSize ! !

!ICUConverterNB methodsFor: 'accessing' stamp: 'jvds 2/24/2012 15:32'!
name

	^ self withStatusDo: [ :status | (self primGetName: status) readString ]! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'jvds 2/24/2012 15:23'!
primClose
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void ucnv_close_48( void* address ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'jvds 2/24/2012 15:57'!
primFromUChars: aDestination with: aDestinationCapacity with: aSource with: aSourceLength with: anErrorCode
	"Convert the Unicode string into a codepage string using an existing UConverter. "
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int ucnv_fromUChars_48( void* address, char* aDestination, int aDestinationCapacity, void* aSource, int aSourceLength, ICUErrorCodeNB* anErrorCode ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'jvds 2/24/2012 15:26'!
primGetName: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( char* ucnv_getName_48( void* address, ICUErrorCodeNB anErrorCode ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'jvds 2/24/2012 15:35'!
primIsAmbiguous
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( bool ucnv_isAmbiguous_48( void* address ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'jvds 2/24/2012 15:34'!
primIsFixedWidth: anErrorCode
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( bool ucnv_isFixedWidth_48( void* address, ICUErrorCodeNB anErrorCode ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'jvds 2/24/2012 16:25'!
primMaxCharSize
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( byte ucnv_getMaxCharSize_48( void* address ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'jvds 2/24/2012 16:25'!
primMinCharSize
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( byte ucnv_getMinCharSize_48( void* address ) )! !

!ICUConverterNB methodsFor: 'primitive calls' stamp: 'jvds 2/24/2012 16:12'!
primToUChars: aDestination with: aDestinationCapacity with: aSource with: aSourceLength with: anErrorCode
	"Convert the Unicode string into a codepage string using an existing UConverter. "
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( int ucnv_toUChars_48( void* address, void* aDestination, int aDestinationCapacity, void* aSource, int aSourceLength, ICUErrorCodeNB* anErrorCode ) )! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 16:17'!
toUChars: aString

	^ self withStatusDo: [ :status |
		| buffer length |
		buffer := ByteArray new: (aString size * 2) + 8.
		length := self primToUChars: buffer with: buffer size / 2 with: aString with: aString size with: status.
		TwoByteString fromByteArray: buffer charSize: length ]! !

!ICUConverterNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 16:09'!
wideStringFromUChars: aString

	^ self withStatusDo: [ :status |
		| buffer length |
		buffer := ByteArray new: 100.
		length := self primFromUChars: buffer with: buffer size with: aString asUTF16Bytes with: aString size * 4 with: status.
		buffer copyFrom: 1 to: length ]! !

!ICUHandleNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:59'!
nbLibraryNameOrHandle

	^'libicui18n.dylib'! !

!ICUHandleNB class methodsFor: 'instance creation' stamp: 'jvds 2/24/2012 14:23'!
newWithAddress: anExternalAddress

	^ self new setAddress: anExternalAddress! !

!ICUHandleNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 15:24'!
nbLibraryNameOrHandle

	^self class nbLibraryNameOrHandle ! !

!ICUHandleNB methodsFor: 'initialize-release' stamp: 'jvds 2/24/2012 14:23'!
setAddress: anExternalAddress

	address := anExternalAddress ! !

!ICUHandleNB methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 15:31'!
withStatusDo: aOneArgBlock

	| status result |
	
	status := ICUErrorCodeNB new.
	result := aOneArgBlock value: status.
	status check.
	^ result! !

ICUHandleNB subclass: #ICULocaleNB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ICU-NativeBoost-Core'!

!ICULocaleNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:03'!
collectionFromArrayOfCharPointers: arrayOfPointers

	^ Array streamContents: [ :stream |
		| index address |
		index := 0.
		[ address := NBExternalAddress value: (arrayOfPointers ulongAt: index). address isNull ] 
			whileFalse: [
				stream nextPut: address readString.
				index := index + 4 ] ]! !

!ICULocaleNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 12:44'!
isoCountries

	| arrayOfPointers|

	arrayOfPointers := self primGetISOCountries.
	^ self collectionFromArrayOfCharPointers: arrayOfPointers! !

!ICULocaleNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:00'!
isoLanguages

	| arrayOfPointers|

	arrayOfPointers := self primGetISOLanguages.
	^ self collectionFromArrayOfCharPointers: arrayOfPointers! !

!ICULocaleNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 12:29'!
nbLibraryNameOrHandle

	^'libicui18n.dylib'! !

!ICULocaleNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 12:27'!
primGetISOCountries
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void* uloc_getISOCountries_48( ) )! !

!ICULocaleNB class methodsFor: 'as yet unclassified' stamp: 'jvds 2/24/2012 13:00'!
primGetISOLanguages
	<primitive: #primitiveNativeCall module: #NativeBoostPlugin>
	
	^ self nbCall: #( void* uloc_getISOLanguages_48( ) )! !
